
// ADC
// FOSC = 7372800 - From a 14745600 Ctal @ HS2 Osc.- mode
// PLL	x8
// FOSC=FCtal/2
// FCY= FOSC*PLL/4
// SAMPLINGRATE1 = 7996.53 Hz 
// SAMPLINGRATE2 =  87252.071  Hz 
// SAMPCOUNT1 = (FCY/SAMPLINGRATE1)+1
// SAMPCOUNT2 = (FCY/SAMPLINGRATE2)+1

#define SAMPCOUNT1  1845                 
#define SAMPCOUNT2  170     


#define BarDelay    100					// Sets the display's orizontal sweeping frequency for the 0,1 and 2 display  modes  
#define BarDelay2   200					// Sets the display's orizontal sweeping frequency for the 3rd display  mode 
#define PeakHold_timeout 500			// The Peaks are being hold for PeakHold_timeout display frames in the 3rd display mode
#define Snap_To_Peak_Timeout 60		    // The Bars climb up to the peak after Snap_To_Peak_Timeout display frames in the 0 display mode 
#define Snap_To_Peak_Timeout2 40		// The Bars climb up to the peak after Snap_To_Peak_Timeout display frames in the 2 display mode 
#define Rain_Timeout		250			// The Rain falls at a rate of 1.3db/Rain_Timeout display frames in the 2 display mode

//FFT
#define NUMSAMP 256                     /* = Number of samples & frequency points in the FFT */
#define LOG2_BLOCK_LENGTH 	8   	    /* = Number of "Butterfly" Stages in FFT processing */

//Display
#define	Threshold1   1      // -30.0 db threshold 		
#define	Threshold2	 2	    // -28.0 db threshold	
#define	Threshold3	 3		// -26.0 db threshold
#define	Threshold4   5		// -24.0 db threshold 
#define	Threshold5	 7		// -22.5 db threshold
#define	Threshold6	 10		// -21.0 db threshold
#define	Threshold7	 13		// -19.5 db threshold	
#define	Threshold8	 19		// -18.0 db threshold
#define	Threshold9   27		// -16.5 db threshold
#define	Threshold10	 38		// -15.0 db threshold	
#define	Threshold11  54 	// -13.5 db threshold
#define	Threshold12  76 	// -12.0 db threshold
#define	Threshold13	 107	// -10.5 db threshold
#define	Threshold14	 151	// -9.0 db threshold
#define	Threshold15	 213	// -7.5 db threshold
#define	Threshold16	 301	// -6.0 db threshold
#define	Threshold17	 426	// -4.5 db threshold
#define	Threshold18	 601	// -3.0 db threshold	
#define	Threshold19	 850	// -1.5 db threshold
#define	Threshold20	 1200	//  0.0 db threshold 03D4

//IO - mapping
#define	X1  PORTDbits.RD8 
#define	X2  PORTGbits.RG2
#define	X3  PORTGbits.RG3
#define	X4  PORTFbits.RF6 
#define	X5  PORTFbits.RF2
#define	X6  PORTFbits.RF5
#define	X7  PORTFbits.RF3 
#define	X8  PORTFbits.RF4
#define	X9  PORTBbits.RB15
#define	X10 PORTBbits.RB14
#define	X11 PORTBbits.RB13 
#define	X12 PORTBbits.RB12
#define	X13 PORTBbits.RB11
#define	X14 PORTBbits.RB10 
#define	X15 PORTBbits.RB5
#define	X16 PORTBbits.RB4
#define	X17 PORTBbits.RB3 
#define	X18 PORTBbits.RB2
#define	X19 PORTBbits.RB7
#define	X20 PORTBbits.RB6

#define	Y1  PORTGbits.RG6 
#define	Y2  PORTGbits.RG15
#define	Y3  PORTGbits.RG13
#define	Y4  PORTGbits.RG12 
#define	Y5  PORTGbits.RG14
#define	Y6  PORTGbits.RG0
#define	Y7  PORTGbits.RG1 
#define	Y8  PORTFbits.RF1
#define	Y9  PORTFbits.RF0
#define	Y10 PORTDbits.RD7
#define	Y11 PORTDbits.RD6 
#define	Y12 PORTDbits.RD5
#define	Y13 PORTDbits.RD4
#define	Y14 PORTDbits.RD3 
#define	Y15 PORTDbits.RD2
#define	Y16 PORTDbits.RD1
#define	Y17 PORTDbits.RD0 
#define	Y18 PORTDbits.RD11
#define	Y19 PORTDbits.RD10
#define	Y20 PORTDbits.RD9

#define	ControlBit1 PORTCbits.RC13
#define	ControlBit2 PORTCbits.RC14

#define	on  1
#define	off 0



