' working version with WAV file and sending wave data to 1 channel of dual DAC
' added routine to search for "data" tag in wavefile, and get size, start of wavefile from there.

$regfile = "m644def.dat"
$crystal = 20000000

Declare Sub Displayclockdigit(byval Digitvalue As Byte , Byval Pos As Byte)
Declare Sub Clkdisplaycolon(byval Pos As Byte):
Declare Sub Displaytime()
Declare Sub Definecustomlcdcharacters()
Declare Sub Gettime()
Declare Sub Settime(s1 As Byte , M1 As Byte , H1 As Byte )
Declare Sub Time_stop()
Declare Sub Time_start()
Declare Sub Settiny84()
Declare Sub Playwakeup()
Declare Function Getredirection() As Integer
Declare Function Getencoder() As Byte



Dim Datalength As Long At $100
Dim Dbyte1 As Byte At $100 Overlay
Dim Dbyte2 As Byte At $101 Overlay
Dim Dbyte3 As Byte At $102 Overlay
Dim Dbyte4 As Byte At $103 Overlay
Dim Tm(7) As Byte At &H104
Dim Sc As Byte At &H104 Overlay
Dim M As Byte At &H105 Overlay
Dim H As Byte At &H106 Overlay
Dim Alarmmin As Byte
Dim Alarmhour As Byte
Dim Gbtemp1 As Byte
Dim I As Byte
Dim Numsounds As Byte                                       ' scratch byte
Dim Zz As Byte
Dim K As Word
Dim J As Word
Dim L As Word
Dim Msb As Byte
Dim Lsb As Byte
Dim Wave(512) As Word
Dim S As String * 15
Dim T As String * 15
Dim Sounds(10) As String * 8
Dim Flen As Long
Dim Fstart As Long
Dim W As Word
Dim Q As Word
Dim X As Long
Dim Flag1 As Boolean
Dim Flag2 As Boolean
Dim D1 As Integer
Dim D2 As Integer
Dim Clockcursx As Byte
Dim Clocktemp1 As Byte
Dim Clocktemp2 As Byte
Dim Htemp As Byte
Dim Mtemp As Byte
Dim Iz As Byte
Dim Timeout As Word
Dim Menuindex As Integer
Dim Rotaryenc As Byte
Dim Reval As Byte
Dim Lastencoder As Byte
Dim Curencoder As Byte
Dim Temp As Integer
Dim Tmp1 As Byte
Dim Tmp2 As Byte
Dim Leftskip As Long
Dim Rightskip As Long
Dim Beatskip As Long
Dim Binauralfreq As Word
Dim Beatfreq As Word
Dim Ltemp As Long
Dim Soundindex As Byte
Dim Dummy As Eram Byte
Dim Nvleftskip As Eram Long
Dim Nvrightskip As Eram Long

$include "config_mmc.bas"
$include "CONFIG_AVR-DOS.Bas"                               ' some constants

Const True = 1
Const False = 0

Mcp4822ncs Alias Portd.7                                    ' WAVE DAC *CS
Config Pind.7 = Output
Set Mcp4822ncs


' set up USART0 as SPI port
Ubrrl = 0
Ubrr0h = 0
Config Portb.0 = Output                                     ' make XCK0 an output for SPI clock
Ucsr0c = &B11000001                                         ' set for SPI mode 0 with MSB sent first
Ucsr0b = &B00001000                                         ' enable  SPI transmitter
Ubrr0l = 0

'set up timer0 as a 22135 hz timer
Tccr0a = &B00000010
Tccr0b = &B00001010                                         ' CLK /8
Ocr0a = 112
' Set up the ISR to be triggered by Timero OCR1A, at 22 KHz rate
On Oc0a Isr:
Enable Oc0a

' Configure the Hardware I2C port used by the PCF85643 RTC chip
$lib "i2c_twi.lbx"
Config Scl = Portc.0
Config Sda = Portc.1
I2cinit                                                     ' we need to set the hardware I2C pins in the proper state
Config Twi = 100000                                         ' desired clock frequency
Call Time_start()

Config Portd.2 = Input
Set Portd.2                                                 ' enable a weak pull up   on Alarm input pin
Alarm Alias Pind.2

Initlcd
' define the custom LCD characters used for the "big" clock readout
Call Definecustomlcdcharacters()


Advanceswitch Alias Pinb.2
Selectswitch Alias Pinb.3
Set Portb.3                                                 ' enable pull up on Select Switch
Set Portb.2                                                 ' enable pull-up on Advance switch

Set Portd.4                                                 ' enable internal pullups on Rotary encoder lines
Set Portd.5

'configure the Reset and COM line used to communicate with the Tiny84 Binaural Beat generator
' note- software UART used, as V9.2 BASCOM compiler would not support the 2nd COM port on the 644

Tiny84reset Alias Porta.0
Config Tiny84reset = Input
Open "comA.1:1200,8,n,1" For Output As #1
' load binaural params from EEPROM
Rightskip = Nvrightskip
Leftskip = Nvleftskip
Call Settiny84()

Lcd "relaxation"
Locate 2 , 1
Lcd "generator"
Wait 4
If Drivecheck() = 0 Then
   Cls                                                      ' we have a card detected
   Lcd "  SD card found"
   _temp1 = Driveinit()                                     ' init the drive
Else
    Lcd " SD card not found"
    End                                                     'end program
End If

Gbtemp1 = Initfilesystem(1)                                 ' we must init the filesystem once
If Gbtemp1 > 0 Then
 Locate 2 , 1
   Lcd "SD card Error " ; Gbtemp1
   Do
   Loop
Else
   Cls
   Lcd "Dsize : " ; Disksize()                              ' show disk size in bytes
   Locate 2 , 1
   Lcd "Dfree: " ; Diskfree()                               ' show free space too
End If




' load up to 10 sound file names
I = 1
S = Dir( "*.wav")
While Len(s) > 0                                            ' if there was a file found
   J = Instr(1 , S , ".")
   Decr J
   S = Left(s , J)
   Sounds(i) = S
   Cls
   Lcd S
   Waitms 200
   Incr I
   If I > 10 Then Exit While
   S = Dir()                                                ' get next
Wend
Decr I
Numsounds = I

Restloop:
Do                                                          ' rest loop simply displays the time in big numerals on LCD
 Call Displaytime()                                         ' and monitors the PCF8563 RTC for an alarm condition
 For I = 1 To 100                                           ' exit from this routine is performed by hitting the Menu advance switch
  Waitms 10
  If Advanceswitch = 0 Then Exit For
 Next
 If Advanceswitch = 0 Then
 Waitms 50
 Bitwait Advanceswitch , Set
  Exit Do
 End If
 If Alarm = 0 Then
   Call Playwakeup()
 End If
Loop

Commandloop:
 Timeout = 600                                              ' after about 30 secs of no user input activity, timeout and go to rest loop (display time)
 Cls
 Locate 1 , 1
 Lcd "Pick a sound"
 Menuindex = 0
 Do
  If Advanceswitch = 0 Then
   Waitms 50
   Bitwait Advanceswitch , Reset
   Cls
   Incr Menuindex
   If Menuindex > 4 Then Menuindex = 0
   Select Case Menuindex
    Case Is = 0 : Lcd "Pick a sound"
    Case Is = 1 : Lcd "Pick Binaur.freq"
    Case Is = 2 : Lcd "Pick Beat Freq "
    Case Is = 3 : Lcd "Set Clock"
    Case Is = 4 : Lcd "Set Alarm"
   End Select
   'debounce the menu advance switch
   Waitms 50
   Bitwait Advanceswitch , Set                              'wait til menu advance switch is released
  End If
  Waitms 10
  If Selectswitch = 0 Then Exit Do
  Waitms 50
  Decr Timeout
 Loop Until Timeout = 0
 If Timeout = 0 Then Goto Restloop
  Bitwait Selectswitch , Set
  Waitms 100
  Bitwait Selectswitch , Set
  Select Case Menuindex
   Case Is = 0 : Goto Play
   Case Is = 1 : Goto Binauralfreq
   Case Is = 2 : Goto Beatfreq
   Case Is = 3 : Goto Setclock
   Case Is = 4 : Goto Setalarm
  End Select
Goto Commandloop

Play:
 Cls
 I = 1
 Locate 2 , 1
 Lcd Sounds(i)
 Do
   Do
      Temp = Getredirection()
      If Selectswitch = 0 Then
        Waitms 50
        If Selectswitch = 0 Then
          Exit Do
        End If
      End If
    Loop Until Temp <> 0
    If Selectswitch = 0 Then Exit Do
    If Temp = 1 Then
       I = I + 1
       If I > Numsounds Then I = 1
    End If
    If Temp = -1 Then
       I = I - 1
       If I = 0 Then I = 1
    End If
    Locate 2 , 1
    Lcd "        "
    Locate 2 , 1
    Lcd Sounds(i)
 Loop
 Soundindex = I
 Waitms 100
 S = Sounds(soundindex) + ".wav"

 Close #10
' open selected wave sound file
 Open S For Binary As #10
 X = 0
' search for the "data" string in the header information
Sch:
  Do
   Incr X
   Get #10 , Dbyte1 , X
  Loop Until Dbyte1 = Asc( "d")
  Incr X
  Get #10 , Dbyte1 , X
  If Dbyte1 <> Asc( "a") Then Goto Sch
  Incr X
  Get #10 , Dbyte1 , X
  If Dbyte1 <> Asc( "t") Then Goto Sch
  Incr X
  Get #10 , Dbyte1 , X
  If Dbyte1 <> Asc( "a") Then Goto Sch
  Incr X
' get the long integer wave file length (flen var is overlayed with dbyte1-4)
  Get #10 , Dbyte1 , X
  Incr X
  Get #10 , Dbyte2 , X
  Incr X
  Get #10 , Dbyte3 , X
  Incr X
  Get #10 , Dbyte4 , X
  Incr X
  Fstart = X
  Get #10 , Wave(1) , X , 1024
  X = X + 1024
  J = 1
  Enable Interrupts                                         ' start wave sound ISR
  Flag1 = False
  Do
   Call Displaytime()
   Flag2 = False
   While Flag2 = False
     If X > Datalength Then
       Flag2 = True
     End If
     Do
     Loop Until J > 256
     Get #10 , Wave(1) , X , 512
     X = X + 512
     Do
     Loop Until J < 256
     Get #10 , Wave(256) , X , 512
     X = X + 512
     If Alarm = 0 Then
      Disable Interrupts
      Call Playwakeup()
      Flag2 = True
      Flag1 = True
     End If
     If Advanceswitch = 0 Then
      Flag2 = True
      Flag1 = True
     End If
     If Selectswitch = 0 Then
      Flag2 = True
      Flag1 = True
      End If
    Wend
    If Flag1 = True Then
      Close #10
      Disable Interrupts                                    ' stop the sound
      Bitwait Selectswitch , Set
      Bitwait Advanceswitch , Set
      Goto Commandloop
    End If
    X = Fstart                                              ' back up to start of wave data
  Loop


Binauralfreq:
 Waitms 100
 Bitwait Selectswitch , Set
 Cls
 Binauralfreq = 250
 Locate 1 , 1
 Lcd "Binaural Freq"
 Locate 2 , 1
 Lcd Binauralfreq
 Do
  Do
     Temp = Getredirection()
     If Selectswitch = 0 Then
       Exit Do
     End If
  Loop Until Temp <> 0
  If Temp = 1 Then
    Binauralfreq = Binauralfreq + 5
    If Binauralfreq > 500 Then Binauralfreq = 500
  End If
  If Temp = -1 Then
     Binauralfreq = Binauralfreq - 5
     If Binauralfreq < 100 Then Binauralfreq = 100
  End If
  If Temp = 0 Then Goto Ex2
  Locate 2 , 1
  Lcd "        "
  Locate 2 , 1
  Lcd Binauralfreq
   'calculate parameters to send to Tiny84 Binaural Beat generator
   Ltemp = Binauralfreq * 362
   Leftskip = Ltemp
   Rightskip = Leftskip + Beatskip
   ' store these values in EEPROM
   Nvrightskip = Rightskip
   Nvleftskip = Leftskip
   Call Settiny84()
Ex2:
  If Selectswitch = 0 Then
    Exit Do
   End If
  Loop
  Waitms 50
  Bitwait Selectswitch , Set
Goto Commandloop


Beatfreq:
Waitms 1 00
 Bitwait Selectswitch , Set
 Cls
 Locate 1 , 1
 Lcd "Beat Frequency"
 Locate 2 , 1
 S = Str(beatfreq)
 T = Format(s , "0.0")
 Lcd T
 Do
  Do
     Temp = Getredirection()
     If Selectswitch = 0 Then
       Exit Do
     End If
  Loop Until Temp <> 0
  If Temp = 1 Then
    Incr Beatfreq
    If Beatfreq > 200 Then Beatfreq = 200
  End If
  If Temp = -1 Then
     Decr Beatfreq
     If Beatfreq < 1 Then Beatfreq = 1
  End If
  If Temp = 0 Then Goto Ex1
  Locate 2 , 1
  S = Str(beatfreq)
  T = Format(s , "0.0")
  Lcd T
   'calculate parameters to send to Tiny84 Binaural Beat generator
   Ltemp = Beatfreq * 36
   Beatskip = Ltemp
   Rightskip = Leftskip + Beatskip
      ' store these values in EEPROM
   Nvrightskip = Rightskip
   Nvleftskip = Leftskip

   Call Settiny84()
  Ex1:
  If Selectswitch = 0 Then
    Exit Do
   End If
 Loop
 Waitms 50
 Bitwait Selectswitch , Set
Goto Commandloop

Setclock:
 Bitwait Selectswitch , Set
 Call Gettime()
 H = H And &H3F
 Htemp = Makedec(h)
 M = M And &H7F
 Mtemp = Makedec(m)
  Cls
 Locate 1 , 1
 Lcd "Hours= ";
 Lcd Htemp
 Do
  Do
    Temp = Getredirection()
    If Selectswitch = 0 Then
      Exit Do
    End If
  Loop Until Temp <> 0
  If Temp = 1 Then
    Incr Htemp
    If Htemp > 23 Then Htemp = 0
  End If
  If Temp = -1 Then
     Decr Htemp
     If Htemp = 255 Then Htemp = 23
  End If
  If Temp = 0 Then Goto Fx2
  Cls
  Locate 1 , 1
  Lcd "Hours= ";
  Lcd Htemp
Fx2:
  If Selectswitch = 0 Then
    Exit Do
   End If
 Loop
                                                                                                                                                                                                       Waitms 50
 Bitwait Selectswitch , Set
  Cls
 Locate 1 , 1
 Lcd "Minutes= ";
 Lcd Mtemp
 Do
  Do
   Temp = Getredirection()
   If Selectswitch = 0 Then
     Exit Do
   End If
  Loop Until Temp <> 0
  If Temp = 1 Then
    Incr Mtemp
    If Mtemp > 59 Then Mtemp = 0
  End If
  If Temp = -1 Then
     Decr Mtemp
     If Mtemp = 255 Then Mtemp = 59
  End If
  If Temp = 0 Then Goto Fx3
  Cls
  Locate 1 , 1
  Lcd "minutes= ";
  Lcd Mtemp
Fx3:
  If Selectswitch = 0 Then
     Exit Do
   End If
 Loop
 Sc = 0
 Call Settime(sc , Mtemp , Htemp )                          'set the time like this  (seconds,minutes,hours)
 Call Displaytime()
 Wait 5
 Cls
Goto Commandloop


Setalarm:
 Waitms 100
 Bitwait Selectswitch , Set
 Tmp1 = 10
 I2creceive &HA3 , Tmp1 , 1 , 1
 Alarmhour = Tmp1 And &H3F
 Htemp = Makedec(alarmhour)
 Cls
 Locate 1 , 1
 Lcd "Alarm hours=";
 Lcd Htemp
 Do
  Do
     Temp = Getredirection()
     If Selectswitch = 0 Then
       Exit Do
     End If
  Loop Until Temp <> 0
  If Temp = 1 Then
    Incr Htemp
    If Htemp > 23 Then Htemp = 0
  End If
  If Temp = -1 Then
     Decr Htemp
     If Htemp = 255 Then Htemp = 23
  End If
  If Temp = 0 Then Goto Ax2
  Cls
  Locate 1 , 1
  Lcd "Alarm Hours=";
  Lcd Htemp
Ax2:
  If Selectswitch = 0 Then
    Exit Do
   End If
 Loop
 Waitms 50
 Bitwait Selectswitch , Set
 Tmp1 = 9
 I2creceive &HA3 , Tmp1 , 1 , 1
 Alarmmin = Tmp1 And &H7F
 Mtemp = Makedec(alarmmin)
 Cls
 Locate 1 , 1
 Lcd "Alarm Mins=";
 Lcd Mtemp
 Do
  Do
     Temp = Getredirection()
     If Selectswitch = 0 Then
       Exit Do
     End If
  Loop Until Temp <> 0
  If Temp = 1 Then
    Incr Mtemp
    If Mtemp > 59 Then Mtemp = 0
  End If
  If Temp = -1 Then
     Decr Mtemp
     If Mtemp = 255 Then Mtemp = 59
  End If
  If Temp = 0 Then Goto Ax3
  Cls
  Locate 1 , 1
  Lcd "Alarm mins=";
  Lcd Mtemp
Ax3:
  If Selectswitch = 0 Then
     Exit Do
   End If
 Loop
 I2cstart                                                   'repeated start
 I2cwbyte &HA2                                              'write mode
 I2cwbyte 9                                                 'select alarm minutes Register
 Tmp1 = Makebcd(mtemp)
 I2cwbyte Tmp1
 Tmp1 = Makebcd(htemp)
 I2cwbyte Tmp1
 Tmp1 = &H80                                                'set all other alarm registers to 0, and disable their enables
 I2cwbyte Tmp1
 I2cwbyte Tmp1
 I2cstop
 I2cstart                                                   'repeated start
 I2cwbyte &HA2                                              'write mode
 I2cwbyte 1                                                 'select Control Status2 Register address
 I2cwbyte 2                                                 'allow an interrupt on INT output pin for an alarm match
 I2cstop
 Cls
 Lcd "Alarm time is ";
 Locate 2 , 1
 Lcd Htemp;
 Lcd ":";
 If Mtemp < 10 Then
  Lcd "0";
 End If
 Lcd Mtemp
 Wait 2
Goto Commandloop

Sub Settiny84()
 Config Tiny84reset = Output
 Reset Tiny84reset
 Waitms 1
 Set Tiny84reset
 Waitms 20
 Printbin #1 , Leftskip ; Rightskip
End Sub

Function Getencoder() As Byte
 Rotaryenc = Pind
 Shift Rotaryenc , Right , 4
 Rotaryenc = Rotaryenc And 3
 Getencoder = Rotaryenc
End Function

Function Getredirection() As Integer
 Curencoder = Getencoder()
 If Lastencoder <> Curencoder Then
    Shift Lastencoder , Left , 1
    Tmp1 = Lastencoder And 2
    Tmp2 = Curencoder And 2
    Tmp1 = Tmp1 Xor Tmp2
    Lastencoder = Curencoder
    If Tmp1 = 0 Then
      Getredirection = 1
    Else
      Getredirection = -1
    End If
 Else
   Getredirection = 0
  End If
End Function

Sub Playwakeup()
     I2cstart                                               'repeated start
     I2cwbyte &HA2                                          'write mode
     I2cwbyte 1                                             'select Control Status2 Register address
     I2cwbyte 0                                             'disable the interrupt on INT output pin on alarm match
     I2cstop
     Close #10
     Disable Interrupts
     Open "WAKEUP.wav" For Binary As #10
     X = 0
' search for the "data" string in the header information
Sch2:
   Do
    Incr X
    Get #10 , Dbyte1 , X
   Loop Until Dbyte1 = Asc( "d")
   Incr X
   Get #10 , Dbyte1 , X
   If Dbyte1 <> Asc( "a") Then Goto Sch2
   Incr X
   Get #10 , Dbyte1 , X
   If Dbyte1 <> Asc( "t") Then Goto Sch2
   Incr X
   Get #10 , Dbyte1 , X
   If Dbyte1 <> Asc( "a") Then Goto Sch2
   Incr X
' get the long integer wave file length (flen var is overlayed with dbyte1-4)
  Get #10 , Dbyte1 , X
  Incr X
  Get #10 , Dbyte2 , X
  Incr X
  Get #10 , Dbyte3 , X
  Incr X
  Get #10 , Dbyte4 , X
  Incr X
  Get #10 , Wave(1) , X , 1024
  X = X + 1024
  J = 1
  Cls
  Locate 1 , 1
  Lcd "alarm"
  Enable Interrupts                                         ' start wave sound ISR
  Flag1 = False
  Flag2 = False
  While Flag2 = False
   If X > Datalength Then
           Flag2 = True
   End If
   Do
   Loop Until J > 256
   Get #10 , Wave(1) , X , 512
   X = X + 512
   Do
   Loop Until J < 256
   Get #10 , Wave(256) , X , 512
   X = X + 512
   If Advanceswitch = 0 Then
       Flag2 = True
       Flag1 = True
   End If
   If Selectswitch = 0 Then
       Flag2 = True
       Flag1 = True
   End If
  Wend
  Close #10
  Disable Interrupts
  If Flag1 = True Then
    Bitwait Selectswitch , Set
    Bitwait Advanceswitch , Set
    Exit Sub
  Else
   For L = 1 To 5000
    Reset Mcp4822ncs                                        'drop *CS
     Msb = &H1F
     Lsb = 0
     Udr0 = Msb
     Udr0 = Lsb
     Waitus 2
     Set Mcp4822ncs
     Waitms 1
     Reset Mcp4822ncs                                       'drop *CS
     Msb = &H10
     Lsb = 0
     Udr0 = Msb
     Udr0 = Lsb
     Waitus 2
     Set Mcp4822ncs
     Waitms 1
   Next
  End If
 End Sub

Sub Gettime()
       Tm(1) = 2                                            ' point to second register
   I2creceive &HA3 , Tm(1) , 1 , 3                          ' write the second address and get 3 bytes back
End Sub

Sub Settime(s1 As Byte , M1 As Byte , H1 As Byte )
    'values are stored as BCD values so convert the values first
    Tm(1) = Makebcd(s1)                                     'seconds
    Tm(2) = Makebcd(m1)                                     'minutes
    Tm(3) = Makebcd(h1)                                     'hours
    Call Time_stop()
    I2cstart                                                'repeated start
    I2cwbyte &HA2                                           'write mode
    I2cwbyte 2                                              'select seconds Register
    For Iz = 1 To 3
     I2cwbyte Tm(iz)
    Next
    I2cstop
    Call Time_start()
End Sub

Sub Time_stop()
    I2cstart                                                'generate start
    I2cwbyte &HA2                                           'write address
    I2cwbyte 0                                              'select control register
    I2cwbyte 32                                             'clock stop
    I2cstop
End Sub

Sub Time_start()
    I2cstart                                                'generate start
    I2cwbyte &HA2                                           'write address
    I2cwbyte 0                                              'select control register
    I2cwbyte 0                                              'clock run
    I2cstop
End Sub

Sub Displaytime()
   Call Gettime()
   Cls
   H = H And &H3F
   Clocktemp1 = H And &H30
   Shift Clocktemp1 , Right , 4
   Call Displayclockdigit(clocktemp1 , 1)
   Clocktemp1 = H And &HF
   Call Displayclockdigit(clocktemp1 , 3)
   Call Clkdisplaycolon(5)
   Clocktemp1 = M And &H70
   Shift Clocktemp1 , Right , 4
   Call Displayclockdigit(clocktemp1 , 6)
   Clocktemp1 = M And &HF
   Call Displayclockdigit(clocktemp1 , 8)
End Sub

Sub Displayclockdigit(byval Digitvalue As Byte , Byval Pos As Byte)
 Clockcursx = Pos
 Select Case Digitvalue
  Case Is = 0 : Gosub Clkdisplay0
  Case Is = 1 : Gosub Clkdisplay1
  Case Is = 2 : Gosub Clkdisplay2
  Case Is = 3 : Gosub Clkdisplay3
  Case Is = 4 : Gosub Clkdisplay4
  Case Is = 5 : Gosub Clkdisplay5
  Case Is = 6 : Gosub Clkdisplay6
  Case Is = 7 : Gosub Clkdisplay7
  Case Is = 8 : Gosub Clkdisplay8
  Case Is = 9 : Gosub Clkdisplay9
 End Select
End Sub

' 0
Clkdisplay0:
Locate 1 , Clockcursx
Lcd Chr(2);
Lcd Chr(4);
Locate 2 , Clockcursx
Lcd Chr(&H4c);
Lcd Chr(5);
Return
' 1
Clkdisplay1:
Locate 1 , Clockcursx
Lcd Chr(&H7c);
Lcd " ";
Locate 2 , Clockcursx
Lcd Chr(&H7c);
Lcd " ";
Return
' 2
Clkdisplay2:
Locate 1 , Clockcursx
Lcd Chr(7);
Lcd Chr(6);
Locate 2 , Clockcursx
Lcd Chr(&H4c);
Lcd Chr(&H5f);
Return
' 3
Clkdisplay3:
Locate 1 , Clockcursx
Lcd Chr(7);
Lcd Chr(6);
Locate 2 , Clockcursx
Lcd Chr(&H5f);
Lcd Chr(5);
Return
' 4
Clkdisplay4:
Locate 1 , Clockcursx
Lcd Chr(&H4c);
Lcd Chr(5);
Locate 2 , Clockcursx
Lcd " ";
Lcd Chr(&H7c);
Return
' 5
Clkdisplay5:
Locate 1 , Clockcursx
Lcd Chr(2);
Lcd Chr(0);
Locate 2 , Clockcursx
Lcd Chr(7);
Lcd Chr(6);
Return
' 6
Clkdisplay6:
Locate 1 , Clockcursx
Lcd Chr(3);
Lcd Chr(7);
Locate 2 , Clockcursx
Lcd Chr(&H4c);
Lcd Chr(5);
Return
' 7
Clkdisplay7:
Locate 1 , Clockcursx
Lcd Chr(0);
Lcd Chr(4);
Locate 2 , Clockcursx
Lcd " " ;
Lcd Chr(&H7c);
Return
' 8
Clkdisplay8:
Locate 1 , Clockcursx
Lcd Chr(2);
Lcd Chr(4);
Locate 2 , Clockcursx
Lcd Chr(3);
Lcd Chr(6);
Return
' 9
Clkdisplay9:
Locate 1 , Clockcursx
Lcd Chr(2);
Lcd Chr(4);
Locate 2 , Clockcursx
Lcd Chr(0);
Lcd Chr(4);
Return

Sub Clkdisplaycolon(byval Pos As Byte):
 Locate 1 , Pos
 Lcd Chr(&H2e);
 Locate 2 , Pos
 Lcd Chr(&H2e);
End Sub

Sub Definecustomlcdcharacters()
' define the custom characters for large Clock display
Deflcdchar 0 , 31 , 32 , 32 , 32 , 32 , 32 , 32 , 32
Deflcdchar 1 , 16 , 16 , 16 , 16 , 16 , 16 , 16 , 16
Deflcdchar 2 , 31 , 16 , 16 , 16 , 16 , 16 , 16 , 16
Deflcdchar 3 , 31 , 16 , 16 , 16 , 16 , 16 , 16 , 31
Deflcdchar 4 , 31 , 1 , 1 , 1 , 1 , 1 , 1 , 1
Deflcdchar 5 , 1 , 1 , 1 , 1 , 1 , 1 , 31 , 32
Deflcdchar 6 , 31 , 1 , 1 , 1 , 1 , 1 , 1 , 31
Deflcdchar 7 , 31 , 32 , 32 , 32 , 32 , 32 , 32 , 31
Cls
End Sub



Isr:
  ' load chan 1
  Reset Mcp4822ncs                                          'drop *CS
  Udr0 = Msb
  Udr0 = Lsb
  D2 = Wave(j)
'  Msb = Low(d1)
'  Lsb = High(d1)
'  D2 = Makeint(lsb , Msb)
  Shift D2 , Right , 4
  D2 = D2 + 2048
  Msb = High(d2)
  Msb = Msb Or &H10
  Lsb = Low(d2)
  Incr J
  If J = 513 Then J = 1
  Set Mcp4822ncs
Return

